#include <hxcpp.h>

#ifndef INCLUDED_snow_platform_native_input_sdl_KeyEventType
#include <snow/platform/native/input/sdl/KeyEventType.h>
#endif
#ifndef INCLUDED_snow_platform_native_input_sdl_KeyEventTypes
#include <snow/platform/native/input/sdl/KeyEventTypes.h>
#endif
namespace snow{
namespace platform{
namespace native{
namespace input{
namespace sdl{

Void KeyEventTypes_obj::__construct()
{
	return null();
}

//KeyEventTypes_obj::~KeyEventTypes_obj() { }

Dynamic KeyEventTypes_obj::__CreateEmpty() { return  new KeyEventTypes_obj; }
hx::ObjectPtr< KeyEventTypes_obj > KeyEventTypes_obj::__new()
{  hx::ObjectPtr< KeyEventTypes_obj > result = new KeyEventTypes_obj();
	result->__construct();
	return result;}

Dynamic KeyEventTypes_obj::__Create(hx::DynamicArray inArgs)
{  hx::ObjectPtr< KeyEventTypes_obj > result = new KeyEventTypes_obj();
	result->__construct();
	return result;}

int KeyEventTypes_obj::ke_down;

int KeyEventTypes_obj::ke_up;

int KeyEventTypes_obj::ke_textedit;

int KeyEventTypes_obj::ke_textinput;

::snow::platform::native::input::sdl::KeyEventType KeyEventTypes_obj::typed( int ke_type){
	HX_STACK_FRAME("snow.platform.native.input.sdl.KeyEventTypes","typed",0x47f6d01c,"snow.platform.native.input.sdl.KeyEventTypes.typed","snow/platform/native/input/sdl/InputSystem.hx",338,0x01aafc86)
	HX_STACK_ARG(ke_type,"ke_type")
	HX_STACK_LINE(340)
	if (((ke_type == ::snow::platform::native::input::sdl::KeyEventTypes_obj::ke_down))){
		HX_STACK_LINE(340)
		return ::snow::platform::native::input::sdl::KeyEventType_obj::down;
	}
	HX_STACK_LINE(341)
	if (((ke_type == ::snow::platform::native::input::sdl::KeyEventTypes_obj::ke_up))){
		HX_STACK_LINE(341)
		return ::snow::platform::native::input::sdl::KeyEventType_obj::up;
	}
	HX_STACK_LINE(342)
	if (((ke_type == ::snow::platform::native::input::sdl::KeyEventTypes_obj::ke_textedit))){
		HX_STACK_LINE(342)
		return ::snow::platform::native::input::sdl::KeyEventType_obj::textedit;
	}
	HX_STACK_LINE(343)
	if (((ke_type == ::snow::platform::native::input::sdl::KeyEventTypes_obj::ke_textinput))){
		HX_STACK_LINE(343)
		return ::snow::platform::native::input::sdl::KeyEventType_obj::textinput;
	}
	HX_STACK_LINE(345)
	return ::snow::platform::native::input::sdl::KeyEventType_obj::unknown;
}


STATIC_HX_DEFINE_DYNAMIC_FUNC1(KeyEventTypes_obj,typed,return )


KeyEventTypes_obj::KeyEventTypes_obj()
{
}

Dynamic KeyEventTypes_obj::__Field(const ::String &inName,bool inCallProp)
{
	switch(inName.length) {
	case 5:
		if (HX_FIELD_EQ(inName,"ke_up") ) { return ke_up; }
		if (HX_FIELD_EQ(inName,"typed") ) { return typed_dyn(); }
		break;
	case 7:
		if (HX_FIELD_EQ(inName,"ke_down") ) { return ke_down; }
		break;
	case 11:
		if (HX_FIELD_EQ(inName,"ke_textedit") ) { return ke_textedit; }
		break;
	case 12:
		if (HX_FIELD_EQ(inName,"ke_textinput") ) { return ke_textinput; }
	}
	return super::__Field(inName,inCallProp);
}

Dynamic KeyEventTypes_obj::__SetField(const ::String &inName,const Dynamic &inValue,bool inCallProp)
{
	switch(inName.length) {
	case 5:
		if (HX_FIELD_EQ(inName,"ke_up") ) { ke_up=inValue.Cast< int >(); return inValue; }
		break;
	case 7:
		if (HX_FIELD_EQ(inName,"ke_down") ) { ke_down=inValue.Cast< int >(); return inValue; }
		break;
	case 11:
		if (HX_FIELD_EQ(inName,"ke_textedit") ) { ke_textedit=inValue.Cast< int >(); return inValue; }
		break;
	case 12:
		if (HX_FIELD_EQ(inName,"ke_textinput") ) { ke_textinput=inValue.Cast< int >(); return inValue; }
	}
	return super::__SetField(inName,inValue,inCallProp);
}

void KeyEventTypes_obj::__GetFields(Array< ::String> &outFields)
{
	super::__GetFields(outFields);
};

static ::String sStaticFields[] = {
	HX_CSTRING("ke_down"),
	HX_CSTRING("ke_up"),
	HX_CSTRING("ke_textedit"),
	HX_CSTRING("ke_textinput"),
	HX_CSTRING("typed"),
	String(null()) };

#if HXCPP_SCRIPTABLE
static hx::StorageInfo *sMemberStorageInfo = 0;
#endif

static ::String sMemberFields[] = {
	String(null()) };

static void sMarkStatics(HX_MARK_PARAMS) {
	HX_MARK_MEMBER_NAME(KeyEventTypes_obj::__mClass,"__mClass");
	HX_MARK_MEMBER_NAME(KeyEventTypes_obj::ke_down,"ke_down");
	HX_MARK_MEMBER_NAME(KeyEventTypes_obj::ke_up,"ke_up");
	HX_MARK_MEMBER_NAME(KeyEventTypes_obj::ke_textedit,"ke_textedit");
	HX_MARK_MEMBER_NAME(KeyEventTypes_obj::ke_textinput,"ke_textinput");
};

#ifdef HXCPP_VISIT_ALLOCS
static void sVisitStatics(HX_VISIT_PARAMS) {
	HX_VISIT_MEMBER_NAME(KeyEventTypes_obj::__mClass,"__mClass");
	HX_VISIT_MEMBER_NAME(KeyEventTypes_obj::ke_down,"ke_down");
	HX_VISIT_MEMBER_NAME(KeyEventTypes_obj::ke_up,"ke_up");
	HX_VISIT_MEMBER_NAME(KeyEventTypes_obj::ke_textedit,"ke_textedit");
	HX_VISIT_MEMBER_NAME(KeyEventTypes_obj::ke_textinput,"ke_textinput");
};

#endif

Class KeyEventTypes_obj::__mClass;

void KeyEventTypes_obj::__register()
{
	hx::Static(__mClass) = hx::RegisterClass(HX_CSTRING("snow.platform.native.input.sdl.KeyEventTypes"), hx::TCanCast< KeyEventTypes_obj> ,sStaticFields,sMemberFields,
	&__CreateEmpty, &__Create,
	&super::__SGetClass(), 0, sMarkStatics
#ifdef HXCPP_VISIT_ALLOCS
    , sVisitStatics
#endif
#ifdef HXCPP_SCRIPTABLE
    , sMemberStorageInfo
#endif
);
}

void KeyEventTypes_obj::__boot()
{
	ke_down= (int)768;
	ke_up= (int)769;
	ke_textedit= (int)770;
	ke_textinput= (int)771;
}

} // end namespace snow
} // end namespace platform
} // end namespace native
} // end namespace input
} // end namespace sdl
